//
// NdisHook.h - by Vito Plantamura - (c) 2003 - All rights reserved.
//

#pragma once

//
// includes.
//

#include <windows.h>
#include "..\Include\IOCTLs.h"

//
// definitions.
//

#define NH_EXPORT			extern "C" __declspec(dllexport)
#define NH_API				_cdecl

//
// prototypes.
//

NH_EXPORT BOOLEAN NH_API Start(
	IN DWORD				dwBacklog,
	IN DWORD				dwLtLoopbackIp,
	IN DWORD				dwLtNatIp,
	OUT PNT_PROTOCOL_LIST*	pplProtocolListPtr
);

NH_EXPORT VOID NH_API Stop(
);

NH_EXPORT BOOLEAN NH_API Listen(
	IN OALIST_ITEM*			piOaList,
	IN LONG					lOaListItems
);

NH_EXPORT BOOLEAN NH_API WaitForPacket(
	OUT HOOK_STATS*			psStats,
	OUT PNEXT_PACKET*		pppPacketPtr
);

NH_EXPORT VOID NH_API FreePacket(
	IN PNEXT_PACKET			ppPacket
);

NH_EXPORT VOID NH_API GetHookStatsFromPacket(
	OUT HOOK_STATS*			psStats,
	IN PNEXT_PACKET			ppPacket
);
